<?
// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

// ####################################################################################

session_start();

require_once("../../shared/ssi/id.phtml");
require_once("../../shared/ssi/tools.phtml");

$LangID = isset($_SESSION['LanguageID']) ? $_SESSION['LanguageID'] : LANG_EN_ISO_8859_1;

// ####################################################################################

function MyURLEncode ($s)
{
    $MyURLEncode = "";
    for ($i = 0; $i < strlen($s); $i++) {
        $c = substr($s,$i,1);
        if (ord($c) == 39) {
            if ($i != 1 && $i != strlen($s) - 1) {
                $c = "\\'";
            }
        }
        if (ord(substr($c, 0, 1)) < 32) {
            $MyURLEncode .= "%". dechex(ord(substr($c, 0, 1))). "%". dechex(ord(substr($c, strlen($c) - 1, 1)));
        } else {
            if (ord($c) <= 127 && ord($c) >= 32) {
                $MyURLEncode .= $c;
            } else {
                $MyURLEncode .= "%". dechex(ord($c));
            }
        }
    }
    return($MyURLEncode);
}

function GenSingleConfigItem (&$RArray, $i, $tabs)
{
    echo "\n". $tabs. "    new parent.Tuple (\n";
    for ($j = 0; $j < $RArray[$i][2]; $j++) {
        if (((int)$RArray[$i][3][$j][2] & CFGENTRY_FLAG_HIDE) == 0) {
            echo $tabs. "        new parent.quintuple (". $RArray[$i][3][$j][0]. ", ";
            echo GenTypedLiteral($RArray[$i][3][$j][1]). ", ";
            echo "'". wgetresourcestring($LangID, MkLWord(GS_IT_CONFIGENTRY, GS_DT_DISPLAYNAME), (int)$RArray[$i][1], (int)$RArray[$i][3][$j][0], 0). "', ";
            echo "0x". HexxD((int)$RArray[$i][3][$j][2], 8). ", 0x". Hex4d($RArray[$i][3][$j][3]). "),\n";
        }
    }
    echo $tabs. "        new parent.quintuple (-1, 0x". HexxD($RArray[$i][0], 8). ", 0x". HexxD($RArray[$i][1], 8). ", 0, 0)\n". $tabs. "    ),\n";
}

function GenConfigItem (&$RArray, $tabs)
{
    for ($i = 0; $i < count($RArray); $i++) {
        GenSingleConfigItem($RArray, $i, $tabs);
    }
}

function GenTblGConfig (&$RArray, $tabs)
{
    if (!is_array($RArray)) {
        return;
    }

    for ($i = 0; $i < count($RArray); $i++) {
        echo $tabs. "    new parent.Tuple (\n";
        for ($j = 0; $j < $RArray[$i][2]; $j++) {
            $s = $RArray[$i][3][$j][1];
            $k = (is_string($RArray[$i][3][$j][1]) ? GenTypedLiteral(MyURLEncode($s)) : $s);
            echo $tabs. "        new parent.triple (". $RArray[$i][3][$j][0]. ", ". $k. ", ";
            if (is_int($RArray[$i][3][$j][1])) {
                $s = $RArray[$i][3][$j][1];
                if ($s != -1 && $s != 9999) {
                    $t = wgetresourcestring($LangID, MkLWord(GS_IT_CONFIGENTRY, GS_DT_VALUE), (int)$RArray[$i][1], (int)$RArray[$i][3][$j][0], (int)$RArray[$i][3][$j][1]);
                    if (strlen($t) != 0) {
                        $s = "'". $t. "'";
                    }
                } else {
                    if ($s == 9999)
                        $s = "''";
                }

                echo $s. "),\n";
            } else {
                echo $k. "),\n";
            }
        }
        echo $tabs. "        new parent.triple (-1, 0x". HexxD($RArray[$i][0], 8). ", 0x". HexxD($RArray[$i][1], 8). ")\n". $tabs. "    ),\n";
    }
}

function &SetCfgItmDiscovery ($discOperator, $discOperand)
{
    $CfgEntry = array();
    $CfgEntry[0] = array();
    $CfgEntry[0][0] = 1;
    $CfgEntry[0][1] = (int)$discOperator;
    $CfgEntry[0][2] = 0x12;
    $CfgEntry[0][3] = 0;
    $CfgEntry[1] = array();
    $CfgEntry[1][0] = 2;
    $CfgEntry[1][1] = (string)$discOperand;
    $CfgEntry[1][2] = 0x2;
    $CfgEntry[1][3] = 0;

    $CfgItem = array();
    $CfgItem[0] = array();
    $CfgItem[0][0] = 1;
    $CfgItem[0][1] = ASWM_CFGTYPE_DISCVY;
    $CfgItem[0][2] = 2;
    $CfgItem[0][3] = $CfgEntry;
    return($CfgItem);
}

function getCurrSegInfo (&$seg, &$mask, &$lupd, &$perc)
{
    $ConfigValues = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY);
    $v = explode("|", $ConfigValues[0][3][2][1], 2);

    if (is_array($v)) {
        $seg = $v[0];
        $mask = $v[1];
        $lupd = $ConfigValues[0][3][4][1];
        $perc = $ConfigValues[0][3][5][1];
    }
}


// ####################################################################################

$LangID = $LangID;

if (!isset($_GET['_'])) {
    $CfgVals = wgetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY_SEGMENTS);

    if (is_array($CfgVals)) {
        $seg = $CfgVals[0][3][0][1];
        $mask = $CfgVals[0][3][1][1];
        $lastupdate = $CfgVals[0][3][2][1];
        $discpercent = $CfgVals[0][3][3][1];
        wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(2, $seg. "|". $mask));
        $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
    }
}

if (strcmp($_GET['_'], "FS") == 0) {
    wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(2, $_GET['__']));
    getCurrSegInfo($seg, $mask, $lastupdate, $discpercent);
    $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
}

if (strcmp($_GET['_'], "RS") == 0) {
    wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(3, $_GET['__']));
    getCurrSegInfo($seg, $mask, $lastupdate, $discpercent);
    $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
    echo "<!-- ". count($CfgVals2). " -->\n";
}

if (strcmp($_GET['_'], "US") == 0) {
    getCurrSegInfo($seg, $mask, $lastupdate, $discpercent);
    $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
}

if (strcmp($_GET['_'], "AS") == 0) {
    wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(3, $_GET['__']));
    getCurrSegInfo($seg, $mask, $lastupdate, $discpercent);
    $CfgVals = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTS);
    $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
}

if (strcmp($_GET['_'], "DS") == 0) {
    wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(4, $_GET['__']));

    $CfgVals = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTS);
    if (is_array($CfgVals)) {
        $seg = $CfgVals[0][3][0][1];
        $mask = $CfgVals[0][3][1][1];
        $lastupdate = $CfgVals[0][3][2][1];
        $discpercent = $CfgVals[0][3][3][1];

        wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(2, $seg. "|". $mask));
        $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
    }
}

if (strcmp($_GET['_'], "DI") == 0) {
    wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(6, $_GET['__']));
    $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
}

if (strcmp($_GET['_'], "AI") == 0) {
    wsetconfigitem(IDV_TYPE_CFGITEM, 1, ASWM_CFGTYPE_DISCVY, SetCfgItmDiscovery(5, $_GET['__']));
    $CfgVals2 = wgetconfigitem(IDV_TYPE_CFGITEM, 0, ASWM_CFGTYPE_DISCVY_SEGMENTIPS);
}



// ####################################################################################
?>
<html>
<script language="JavaScript1.2" src="../../shared/jsdata/stl.js"></script>
<body onLoad="bodyReady()" BGCOLOR="#DBDBDB">
</body>
<script language="JavaScript1.2">
function bodyReady ()
{
    if (!parent.segments || !parent.banner || !parent.ips) {
        setTimeout('bodyReady ()', parent.opener.parent.__retryInMsec__);
        return;
    }

    parent.inAction = false;
    parent.sortIPBy = 0;
    parent.sortIPOrder = false;
<?
if (!isset($_GET['_']) || strcmp($_GET['_'], "DS") == 0 || strcmp($_GET['_'], "AS") == 0) {

    if (is_array($CfgVals)) {?>
    parent.allSegments = false;
    parent.allSegments = new parent.Tuple (
<?
    GenConfigItem($CfgVals, str_repeat(" ", 4));
?>
        false
    );

    parent.allSegments.sort(parent.sortSeg);
    parent.focusedSegment = '<?= $seg ?>|<?= $mask ?>|<?= $lastupdate ?>|<?= $discpercent ?>';
    parent.segments.location.replace("../discvseg.htm");
    parent.banner.location.replace("../discvbnr.htm");
    parent.IPofFocusedSegment = false;
<?
    }

    if (is_array($CfgVals2)) {?>
    parent.IPofFocusedSegment = new parent.Tuple (
<?
    GenTblGConfig($CfgVals2, str_repeat(" ", 4));
?>
        false
    );

    parent.IPofFocusedSegment.sort(parent.sortIP);
<?
    }?>
    parent.ips.location.replace("../discvip.htm");
<?
}

if (strcmp($_GET['_'], "FS") == 0 || strcmp($_GET['_'], "DI") == 0 ||
    strcmp($_GET['_'], "RS") == 0 || strcmp($_GET['_'], "AI") == 0 ||
    strcmp($_GET['_'], "US") == 0) {

    if (is_array($CfgVals2)) {?>
    parent.IPofFocusedSegment = new parent.Tuple (
<?
    GenTblGConfig($CfgVals2, str_repeat(" ", 4));
?>
        false
    );
<?
    }

    if (strcmp($_GET['_'], "FS") == 0) {?>
    parent.focusedSegment = '<?= $seg ?>|<?= $mask ?>|<?= $lastupdate ?>|<?= $discpercent ?>';
    parent.segments.location.replace("../discvseg.htm");
    parent.banner.location.replace("../discvbnr.htm");
<?
    }

    if (strcmp($_GET['_'], "DI") == 0 || strcmp($_GET['_'], "RS") == 0 ||
       strcmp($_GET['_'], "AI") == 0) {?>
    parent.banner.location.replace("../discvbnr.htm");
<?
    }

    if (strcmp($_GET['_'], "US") == 0 || strcmp($_GET['_'], "RS") == 0) {?>
    parent.focusedSegment = '<?= $seg ?>|<?= $mask ?>|<?= $lastupdate ?>|<?= $discpercent ?>';
    parent.banner.location.replace("../discvbnr.htm");
<?
    }

//    if (is_array($CfgVals2)) {?>
    if (parent.IPofFocusedSegment) {
        parent.IPofFocusedSegment.sort(parent.sortIP);
        parent.ips.location.replace("../discvip.htm");
    }
<?
//    }
}

?>
}
</script>
</html>
