// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];

var snridMBTemperature =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridCPU1Temperature =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0110;
var snridCPU2Temperature =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0120;

var snridVcore1Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;
var snridVcore2Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0120;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0120;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0150;
var snridFan6Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0160;

var compPCI = new SysComponentInfo ('PCI', "parent.I18N['EXPANDSLOTS']", 'info_pci.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 3, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 3, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 4, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 4, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 5, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 5, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 7).extra", snsridHasDMI)
    )
);
var compFan1 = new SysComponentInfo ('FAN1', "parent.once.GSensorNames[parent.once.snridFan1Speed]", 'info_frontfan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan1Speed).unit]", snridFan1Speed)
    )
);
var compFan2 = new SysComponentInfo ('FAN2', "parent.once.GSensorNames[parent.once.snridFan2Speed]", 'info_cpufan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan2Speed).unit]", snridFan2Speed)
    )
);
var compFan3 = new SysComponentInfo ('FAN3', "parent.once.GSensorNames[parent.once.snridFan3Speed]", 'info_cpufan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan3Speed).unit]", snridFan3Speed)
    )
);
var compFan4 = new SysComponentInfo ('FAN4', "parent.once.GSensorNames[parent.once.snridFan4Speed]", 'info_frontfan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan4Speed).unit]", snridFan4Speed)
    )
);
var compFan5 = new SysComponentInfo ('FAN5', "parent.once.GSensorNames[parent.once.snridFan5Speed]", 'info_rearfan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan5Speed).unit]", snridFan5Speed)
    )
);
var compFan6 = new SysComponentInfo ('FAN6', "parent.once.GSensorNames[parent.once.snridFan6Speed]", 'info_rearfan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan6Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan6Speed).unit]", snridFan6Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_winbond.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature).unit]", snridMBTemperature),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).unit]", snridCPU1Temperature),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).unit]", snridCPU2Temperature)
    )
);
var compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
    new Tuple (
        new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI)
    )
);
var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu1.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcore1Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).unit]", snridCPU1Temperature),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore1Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).unit]", snridVcore1Voltage)
    )
);
var compCPU2 = new SysComponentInfo ('CPU2', "parent.I18N['CPU'] + ' 2'", 'info_cpu2.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 2, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 2, 13).value + 'Mhz'", snridVcore2Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).unit]", snridCPU2Temperature),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore2Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).unit]", snridVcore2Voltage)
    )
);

var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var theSystemComponents = new Tuple (
    compIOConnector, 
    compFan1, 
    compFan2, 
    compFan3, 
    compFan4, 
    compFan5, 
    compFan6, 
    compMotherboard, 
    compMemory, 
    compPCI, 
    compCPU1, 
    compCPU2
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/nclv-ds/';
var theSystem = new SysModel ('model.jpg', chassis_tower);

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 45,  18,  60,  37), compMotherboard),
            new AnArea (new Rect (125,  42, 136,  54), compFan6),
            new AnArea (new Rect (241,  30, 252,  42), compFan5),
            new AnArea (new Rect (108, 211, 119, 223), compFan4),
            new AnArea (new Rect (123, 135, 134, 150), compFan3),
            new AnArea (new Rect (183, 136, 194, 151), compFan2),
            new AnArea (new Rect (118, 211, 129, 223), compFan1),
            new AnArea (new Rect ( 48,  38, 125, 144), compPCI),
            new AnArea (new Rect (195,  22, 227, 147), compMemory),
            new AnArea (new Rect (144, 164, 189, 211), compCPU2),
            new AnArea (new Rect (210, 164, 255, 211), compCPU1)
        ),
        new Tuple (
            new quadruple ('AL_FAN1', parent.asID['IDV_TYPE_SNR'], snridFan1Speed, new Point (120, 213)),
            new quadruple ('AL_FAN2', parent.asID['IDV_TYPE_SNR'], snridFan2Speed, new Point (185, 139)),
            new quadruple ('AL_FAN3', parent.asID['IDV_TYPE_SNR'], snridFan3Speed, new Point (125, 138)),
            new quadruple ('AL_FAN4', parent.asID['IDV_TYPE_SNR'], snridFan4Speed, new Point (110, 213)),
            new quadruple ('AL_FAN5', parent.asID['IDV_TYPE_SNR'], snridFan5Speed, new Point (243, 32)),
            new quadruple ('AL_FAN6', parent.asID['IDV_TYPE_SNR'], snridFan6Speed, new Point (127, 44)),
            new quadruple ('AL_CPU2TEMP', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature, new Point (165, 179)),
            new quadruple ('AL_CPU1TEMP', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature, new Point (230, 179)),
            new quadruple ('AL_VCORE2', parent.asID['IDV_TYPE_SNR'], snridVcore2Voltage, new Point (165, 179)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcore1Voltage, new Point (230, 179)),
            new quadruple ('AL_MBTEMP', parent.asID['IDV_TYPE_SNR'], snridMBTemperature, new Point (50, 22))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect (5, 105, 143, 135), compIOConnector)
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['USB_PORT']", "2"
    )
);


