// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

var divDiskInfos;
var divDiskInfoPopups;
var showDivDiskInfos;

var snsrBelongsToDisks;

function showhide_property (m, i)
{
    var j, ofs;

    if (divSnsrProperty[m]) {
        if (showSnsrProperty[m]) {
            ofs = (- divSnsrProperty[m].offsetHeight);
            divSnsrProperty[m].style.visibility = 'hidden';
            showSnsrProperty[m] = false;
        } else {
            if (divSnsrThreshold[m])
                if (showSnsrThreshold[m]) {
                    showhide_threshold(m, i);
                }
            ofs = (+ divSnsrProperty[m].offsetHeight);
            divSnsrProperty[m].style.visibility = 'visible';
            showSnsrProperty[m] = true;
        }
        for (j = m + 1; j < divSnsrs.length; j++) {
            divSnsrs[j].style.top = parseInt(divSnsrs[j].style.top) + ofs;
            divSnsrImages[j].style.top = parseInt(divSnsrImages[j].style.top) + ofs;
            if (divSnsrThreshold[j])
                divSnsrThreshold[j].style.top = parseInt(divSnsrThreshold[j].style.top) + ofs;
            if (divSnsrProperty[j])
                divSnsrProperty[j].style.top = parseInt(divSnsrProperty[j].style.top) + ofs;
        }
        for (j = i + 1; j < divDiskInfos.length; j++) {
            divDiskInfos[j].style.top = parseInt(divDiskInfos[j].style.top) + ofs;
            divDiskInfoPopups[j].style.top = parseInt(divDiskInfoPopups[j].style.top) + ofs;
        }
    }
}


function showhide_threshold (m, i)
{
    var j, ofs;

    if (divSnsrThreshold[m]) {
        if (showSnsrThreshold[m]) {
            ofs = (- divSnsrThreshold[m].offsetHeight);
            divSnsrThreshold[m].style.visibility = 'hidden';
            showSnsrThreshold[m] = false;
        } else {
            if (divSnsrProperty[m])
                if (showSnsrProperty[m]) {
                    showhide_property(m, i);
                }
            ofs = (+ divSnsrThreshold[m].offsetHeight);
            divSnsrThreshold[m].style.visibility = 'visible';
            showSnsrThreshold[m] = true;
        }
        for (j = m + 1; j < divSnsrs.length; j++) {
            divSnsrs[j].style.top = parseInt(divSnsrs[j].style.top) + ofs;
            divSnsrImages[j].style.top = parseInt(divSnsrImages[j].style.top) + ofs;
            if (divSnsrThreshold[j])
                divSnsrThreshold[j].style.top = parseInt(divSnsrThreshold[j].style.top) + ofs;
            if (divSnsrProperty[j])
                divSnsrProperty[j].style.top = parseInt(divSnsrProperty[j].style.top) + ofs;
        }
        for (j = i + 1; j < divDiskInfos.length; j++) {
            divDiskInfos[j].style.top = parseInt(divDiskInfos[j].style.top) + ofs;
            divDiskInfoPopups[j].style.top = parseInt(divDiskInfoPopups[j].style.top) + ofs;
        }
    }
}

function showhide_diskproperty (i)
{
    var j, k, ofs;

    if (divDiskInfoPopups[i]) {
        if (showDivDiskInfos[i]) {
            ofs = (- divDiskInfoPopups[i].offsetHeight);
            divDiskInfoPopups[i].style.visibility = 'hidden';
            showDivDiskInfos[i] = false;
        } else {
            ofs = (+ divDiskInfoPopups[i].offsetHeight);
            divDiskInfoPopups[i].style.visibility = 'visible';
            showDivDiskInfos[i] = true;
        }
        for (j = i; j < divDiskInfos.length; j++) {
            if (snsrBelongsToDisks[j]) {
                var x = snsrBelongsToDisks[j].split(',');
                for (k = 0; k < x.length; k++) {
                    var f = parseInt(x[k]);

                    divSnsrs[f].style.top = parseInt(divSnsrs[f].style.top) + ofs;
                    divSnsrImages[f].style.top = parseInt(divSnsrImages[f].style.top) + ofs;
                    if (divSnsrThreshold[f])
                        divSnsrThreshold[f].style.top = parseInt(divSnsrThreshold[f].style.top) + ofs;
                    if (divSnsrProperty[f])
                        divSnsrProperty[f].style.top = parseInt(divSnsrProperty[f].style.top) + ofs;
                }
            }
        }
        for (j = i + 1; j < divDiskInfos.length; j++) {
            divDiskInfos[j].style.top = parseInt(divDiskInfos[j].style.top) + ofs;
            divDiskInfoPopups[j].style.top = parseInt(divDiskInfoPopups[j].style.top) + ofs;
        }
    }
}

function switchHealthSignState (flag)
{
    var i, k, snsr;

    if (divSnsrImages)
        for (i = 0; i < parent.once.GSensors.length(); i++) {
            if (parent.once.GSensors.at(i).sensors) {
                for (k = 0; k < parent.once.GSensors.at(i).sensors.length(); k++) {
                    snsr = parent.once.GSensors.at(i).sensors.at(k);
                    if (document.images['i' + snsr.id])
                        if (flag) {
                            document.images['i' + snsr.id].src = getSnsrHealthSign(snsr.currstatus);
                        } else {
                            document.images['i' + snsr.id].src = "./img/z/i-blank.gif";
                        }

                }
            }
        }
}

function once (ignored)
{
    var i, j, k, m, ss, div, div2, div3, div4, functype, snsr;

    if (__onceCalled__ && !ignored) {
        if (divSTWatch) {
            divSTWatch.style.visibility = 'hidden';
        }
        return;
    }

    __onceCalled__ = true;

    if (!vwOrg)
        vwOrg = getDocObject('vw');

    if (!divSnsrs) {
        divSnsrs = new Array();
        divSnsrImages = new Array();
        snsrMin = new Array();
        snsrAvg = new Array();
        snsrMax = new Array();
        divSnsrThreshold = new Array();
        divSnsrProperty = new Array();
        showSnsrThreshold = new Array();
        showSnsrProperty = new Array();

        divDiskInfos = new Array ();
        divDiskInfoPopups = new Array ();
        showDivDiskInfos = new Array ();
        snsrBelongsToDisks = new Array ()
    }

    lastGSensorNumber = parent.once.GSensors.length();

    for (m = i = 0; i < parent.once.GSensors.length(); i++) {
        var isfloppy = false;
        var iscdrom = false;
        var isdisk = true;

        if (parent.once.GSensors.at(i).property && parent.once.GSensors.at(i).id.substr(0,1) == 'X') {
            if (parent.once.GSensors.at(i).property.length() > 2) {
                iscdrom = true;
                isdisk = false;
            } else {
                isfloppy = true;
                isdisk = false;
            }
        }
        if (!divDiskInfos[i]) {
            div = divDiskInfos[i] = document.createElement('DIV');
            div.style.visibility = 'visible';
            div.style.position = 'absolute';
            div.style.left = getOffsetLeft(vwOrg);
            div.style.top = getOffsetTop(vwOrg) + heightOfSensors;
            div.id = 'disk' + i;
            div.style.zIndex = 0;
            document.body.appendChild(div);
        }

        j = '';

        j += (i > 0 ? '<BR>' : '') +
'<TABLE BGCOLOR="#DBDBDB" WIDTH="595" BORDER="0" CELLPADDING="0" CELLSPACING="0"><TR><TD WIDTH="580">' +
'    <TABLE WIDTH="200" height="25" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'        <TR><TD WIDTH="23" background="./img/z/set_hd_t2bg.gif"><IMG SRC="./img/z/set_hd_t1.gif" BORDER="0" ></TD>' +
'            <TD WIDTH="41" background="./img/z/set_hd_t2bg.gif">' +
            (isdisk ? '<IMG SRC="./img/z/set_i_hd.gif">' : (iscdrom ? '<IMG SRC="./img/z/set_i_cd.gif">' : (isfloppy ? '<IMG SRC="./img/z/set_i_a.gif">' : ''))) +
        '</TD>' +
'            <TD WIDTH="70" background="./img/z/set_hd_t2bg.gif"><font class=t11b valign=middle><nobr>&nbsp;' +
            (isdisk ? parent.I18N['DISK'] : (iscdrom ? parent.I18N['CDDVDROM'] : (isfloppy ? parent.I18N['FLOPPY'] : ''))) + (isdisk ? ' ' +  parent.once.GSensors.at(i).id.substr(1,1) : '')  + '&nbsp;</nobr></font></TD>' +
'            <TD WIDTH="22">' + ( parent.once.GSensors.at(i).property ? '<a href="javascript:showhide_diskproperty(' + i + ');" onMouseOut="hs_swapImgRestore()" onMouseOver="hs_swapImage(&quot;property' + i + '&quot;,&quot;&quot;,&quot;./img/z/set_bu0_o.gif&quot;,1)"><img src="./img/z/set_bu0.gif" name="property' + i + '" width="22" height="25" border="0"></a>' : '') + '</TD>' +
'            <TD WIDTH="42"><IMG SRC="./img/z/set_hd_t3.gif" BORDER="0" ></TD></TR></TABLE><BR>';
        writeHTML('disk' + i, j);
        heightOfSensors += divDiskInfos[i].offsetHeight

        if (parent.once.GSensors.at(i).property) {
            if (!divDiskInfoPopups[i]) {
                div = divDiskInfoPopups[i] = document.createElement('DIV');
                div.style.visibility = 'hidden';
                div.style.position = 'absolute';
                div.style.left = getOffsetLeft(vwOrg);
                div.style.top = getOffsetTop(vwOrg) + heightOfSensors;
                div.id = 'diskpp' + i;
                div.style.zIndex = 0;
                document.body.appendChild(div);
            }

            j = '';

            j +=
'<TABLE WIDTH="580" BORDER="0" CELLPADDING="0" CELLSPACING="5">' +
'<TR><TD width="20"><IMG SRC="./img/z/bg.gif" BORDER="0" ></TD>' +
'    <TD WIDTH="560"><TABLE border="0" width="100%" CELLPADDING="0" CELLSPACING="0">' +
'        <TR><TD height="10" width="10" align=right><IMG SRC="./img/z/property_01.gif" BORDER="0" ></TD>' +
'            <TD height="10" background="./img/z/property_02bg.gif"><IMG SRC="./img/z/bg.gif" BORDER="0" ></TD>' +
'            <TD height="10" width="10"><IMG SRC="./img/z/property_03.gif" BORDER="0" ></TD></TR>' +
'        <TR><TD width="10" background="./img/z/property_04bg.gif"><IMG SRC="./img/z/bg.gif" BORDER="0" ></TD>' +
'            <TD width="100%"><TABLE border="0" height="" width="100%" bgcolor="#F2F2F2" CELLPADDING="0" CELLSPACING="0">' +
'                <TR><TD width="" height="16" bgcolor="#E8ECEF" align=center class=t8b_blue>' + parent.I18N['PROPERTIES'] + '</TD>' +
'                    <TD width="" colspan="2" bgcolor="#CED5DC" align=center class=t8b_blue>' + parent.I18N['VALUES'] + '</TD></TR>';

            for (k = 0; k < parent.once.GSensors.at(i).property.length() - 1; k++) {
                j +=
'                <TR><TD width="60%" height="16">' + parent.once.GSensors.at(i).property.at(k).extra.replace(/</g, "&lt;") + '</TD><TD width="35%" bgcolor="#F2F2F2" class=t8_blue><span id="dskp' + i + 'a' + k + '">' + String(parent.once.GSensors.at(i).property.at(k).value).replace(/</g, "&lt;") + '</span></TD><TD width="5%" align=right bgcolor="#F2F2F2" class=t8_blue><nobr>' + parent.once.GResUnit[parent.once.GSensors.at(i).property.at(k).misc] + '</nobr></TD></TR>';

                if (k < parent.once.GSensors.at(i).property.length() - 2) {
                    j +=
'                <TR><TD width="100%" align=center colspan="3" background="./img/z/form_bg4.gif"><IMG SRC="./img/z/bg.gif" BORDER="0" ></TD></TR>';
                }
            }

            j +=
'                </TABLE></TD>' +
'            <TD width="10" background="./img/z/property_05bg.gif"><IMG SRC="./img/z/bg.gif" BORDER="0" ></TD></TR>' +
'         <TR><TD width="10" height="10" align=right><IMG SRC="./img/z/property_06.gif" BORDER="0" ></TD>' +
'             <TD height="10" background="./img/z/property_07bg.gif"><IMG SRC="./img/z/bg.gif" BORDER="0" ></TD>' +
'             <TD width="10" height="10"><IMG SRC="./img/z/property_08.gif" BORDER="0" ></TD></TR></TABLE></TD></TR></TABLE>';

            writeHTML('diskpp' + i, j);
        }

        ss = '';
        if (parent.once.GSensors.at(i).sensors) {
            for (k = 0; k < parent.once.GSensors.at(i).sensors.length(); k++, heightOfSensors += divSnsrs[m++].offsetHeight) {
                snsr = parent.once.GSensors.at(i).sensors.at(k);
                functype = snsr.functype;
                j = '';
                ss += ',' + m;

                if (!divSnsrs[m]) {
                    div = divSnsrs[m] = document.createElement('DIV');
                    div.style.visibility = 'visible';
                    div.style.position = 'absolute';
                    div.style.left = getOffsetLeft(vwOrg) + 20;
                    div.style.top = getOffsetTop(vwOrg) + heightOfSensors;
                    div.id = 'sensor' + m;
                    div.style.zIndex = 0;
                    document.body.appendChild(div);
                    snsrMin[m] = Number.POSITIVE_INFINITY;
                    snsrAvg[m] = 0;
                    snsrMax[m] = Number.NEGATIVE_INFINITY;

                    div2 = divSnsrImages[m] = document.createElement('DIV');
                    div2.style.visibility = 'visible';
                    div2.style.position = 'absolute';
                    div2.style.left = getOffsetLeft(vwOrg) + 1 + 20;
                    div2.style.top = getOffsetTop(vwOrg) + heightOfSensors + (functype != ASWM_FNTYPE_NONE && functype != ASWM_FNTYPE_CV ? 23 : 0) + 1;
                    div2.id = 'snsr' + m;
                    div2.style.zIndex = 1;
                    document.body.appendChild(div2);
                    writeHTML('snsr' + m, '<IMG NAME="i' + snsr.id + '" SRC="' + getSnsrHealthSign(snsr.currstatus) + '">');
                }

                writeHTML('sensor' + m, createSnsrBar(m, snsr, m, i));
            }
        }
        snsrBelongsToDisks[i] = ss.substr(1);
    }

    if (divSTWatch) {
        divSTWatch.style.visibility = 'hidden';
    }

    allDivsReady = true;
}

function rstSnrView ()
{
    divDiskInfos = removeDivChilds(divDiskInfos);
    divDiskInfoPopups = removeDivChilds(divDiskInfoPopups);
    divSnsrs = removeDivChilds(divSnsrs);
    divSnsrImages = removeDivChilds(divSnsrImages);

    if (divSTWatch) {
        divSTWatch.style.visibility = 'visible';
    }

    heightOfSensors = 0;
    showDivDiskInfos = false;
    snsrBelongsToDisks = false;

    refreshCount = 0;
}

function periodical ()
{
    var o, i, j, k, m, ss, functype, snsr, offst, offst2, bleft, bright;

    if (!allDivsReady)
        return;

    if (lastGSensorNumber != parent.once.GSensors.length()) {
        rstSnrView();
        once(true);
    }

    for (m = i = 0; i < parent.once.GSensors.length(); i++) {
        if (parent.once.GSensors.at(i).property) {
            for (k = 0; k < parent.once.GSensors.at(i).property.length() - 1; k++) {
                if ((o = getDocObject('dskp' + i + 'a' + k)) != null) {
                    writeHTML('dskp' + i + 'a' + k, 
                        String(parent.once.GSensors.at(i).property.at(k).value).replace(/</g, "&lt;")
                    );
                }
            }
        }
        if (parent.once.GSensors.at(i).sensors) {
            for (k = 0; k < parent.once.GSensors.at(i).sensors.length(); k++, m++) {
                snsr = parent.once.GSensors.at(i).sensors.at(k);
                functype = snsr.functype;

                if ((o = getDocObject('snsrvalstatus' + snsr.id)) != null) {
                    writeHTML('snsrvalstatus' + snsr.id,
        '                <TABLE width="194" height="16" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
        '                <TR><TD width="140" class="' + getSnsrHealthCSSClass(snsr.currstatus) + '">' + getSnsrHealthString(snsr.currstatus) + '</TD><TD width="54" align=right class=t8b>' + 
                        (parent.tblSeqResources[snsr.id] || parent.tblBtfResources[snsr.id]? '': snsr.currvalue) + 
                        '</TD></TR></TABLE>'
                    );
                }

                if ((o = getDocObject('snsrevt' + snsr.id)) != null) {
                    if (snsr.eventtime && snsr.currstatus != snsr.prevstatus) {
                        var dd = new Date();
                        dd.setTime(snsr.eventtime * 1000);
                        writeHTML('snsrevt' + snsr.id,
                            (snsr.prevstatus != snsr.currstatus ? '(' + dd.getFullYear() + '/' + dd.getMonth() + '/' + dd.getDate() + ' ' + dd.getHours() + ':' + dd.getMinutes() + ')' : '')
                        );
                    } else {
                        writeHTML('snsrevt' + snsr.id, '');
                    }
                }

                if ((o = getDocObject('snsrevtdesc' + snsr.id)) != null) {
                    if (snsr.eventtime) {
                        if (!(snsr.currstatus == snsr.prevstatus && snsr.currstatus == 0))
                            writeHTML('snsrevtdesc' + snsr.id, 
                                (snsr.prevstatus != snsr.currstatus ? getSnsrHealthDesc(snsr.currstatus) : '')
                            );
                    } else {
                            writeHTML('snsrevtdesc' + snsr.id, '');
                    }
                }

                if ((o = getDocObject('snsrmoredesc' + snsr.id)) != null) {
                    writeHTML('snsrmoredesc' + snsr.id,
                        (parent.tblSeqResources[snsr.id] || parent.tblBtfResources[snsr.id]? getSnsrHealthDesc2(snsr.id, snsr.currvalue, snsr.currstatus, "<br>"):
                            (snsr.prevstatus != snsr.currstatus ? getSnsrHealthDesc2(snsr.id, snsr.currvalue, snsr.currstatus, "<br>") : ''))
                    );
                }
            }
        }
    }

    if (divSTWatch) {
        divSTWatch.style.visibility = 'hidden';
    }

    refreshCount++;
}