// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

var wndVNC = null;
function openVNC ()
{
    var win_width, win_height, win_left, win_top;

    if (!parent.__firewallPast__ || !parent.__startSuccessfully__)
        return;

    if (wndVNC) {
        if (!wndVNC.closed) {
            wndVNC.focus() ;
            return ;
        }
        else wndVNC=null ;
    }
    win_width = 860;
    win_height = 600;
    win_left = (screen.width - win_width) / 2;
    win_top = (screen.height - win_height - 75) / 2;

    if (parent.once.GConfigs) {
        if (parent.once.GConfigs.at(0)) {
            if (parent.once.GConfigs.at(0).quintupleValueAt(-1) == parent.asID['ASWM_CFGGROUP_ASWM']) {
                var strVNCPath = "http://" + self.window.location.hostname + ":" + (parent.asID['VNCBaseHTTPPort'] + parent.once.GConfigs.at(0).quintupleValueAt(parent.asID['ASWMCFG_DesiredVNCDispNo'])).toString() + "/";
                if (navigator.appName == "Netscape")
                    wndVNC = window.open(strVNCPath, "VNC", 'toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width='+win_width+',height='+win_height+',screenX='+win_left+',screenY='+win_top);
                else
                    wndVNC = window.open(strVNCPath, "VNC", 'toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width='+win_width+',height='+win_height+',left='+win_left+',top='+win_top);
            }
        }
    }
}

var wndDiscovery = null;
function openDiscovery ()
{
	var strDiscoveryPath = parent.__defWebAppPathPrefix__ + "/discovery/discovery.htm" ;
    var win_width, win_height, win_left, win_top;

    if (!parent.__firewallPast__ || !parent.__startSuccessfully__)
        return;

    if (wndDiscovery)
	{
		if (!wndDiscovery.closed)
		{
			wndDiscovery.focus() ;
			return ;
		}
		else wndDiscovery=null ;
	}
    win_width = 860;
    win_height = 600;
    win_left = (screen.width - win_width) / 2;
    win_top = (screen.height - win_height - 75) / 2;

    if (navigator.appName == "Netscape")
		wndDiscovery = window.open(strDiscoveryPath, "discovery", 'toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width='+win_width+',height='+win_height+',screenX='+win_left+',screenY='+win_top);
	else
		wndDiscovery = window.open(strDiscoveryPath, "discovery", 'toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width='+win_width+',height='+win_height+',left='+win_left+',top='+win_top);
}

var wndAbout = null;
function openAbout ()
{
	var strAboutPath = parent.__defWebAppPathPrefix__ + "/about.htm" ;
    var win_width, win_height, win_left, win_top;

	if (wndAbout) {
		if (!wndAbout.closed) {
			wndAbout.focus() ;
			return ;
		}
		else wndAbout=null ;
	}
    win_width = 505;
    win_height = 415;
    win_left = (screen.width - win_width) / 2;
    win_top = (screen.height - win_height - 75) / 2;

    if (navigator.appName == "Netscape")
		wndAbout = window.open(strAboutPath, "About", 'toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width='+win_width+',height='+win_height+',screenX='+win_left+',screenY='+win_top);
	else
		wndAbout = window.open(strAboutPath, "About", 'toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width='+win_width+',height='+win_height+',left='+win_left+',top='+win_top);
}

var wndHelp = null;
function openHelp ()
{
	var strHelpPath = parent.__defWebAppPathPrefix__ + "/help/" ;
    var win_width, win_height, win_left, win_top;

    if (!parent.__firewallPast__ || !parent.__startSuccessfully__)
        return;

    if (!parent.__helpInstalled__) {
        alert(parent.I18N['NO_HELP_INSTALLED']);
        return;
    }

    if (wndHelp)
	{
		if (!wndHelp.closed)
		{
			wndHelp.focus() ;
			return ;
		}
		else wndHelp=null ;
	}
    win_width = 860;
    win_height = 600;
    win_left = (screen.width - win_width) / 2;
    win_top = (screen.height - win_height - 75) / 2;

    if (navigator.appName == "Netscape")
		wndHelp = window.open(strHelpPath, "Help", 'toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width='+win_width+',height='+win_height+',screenX='+win_left+',screenY='+win_top);
	else
		wndHelp = window.open(strHelpPath, "Help", 'toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width='+win_width+',height='+win_height+',left='+win_left+',top='+win_top);
}


function findSetConfigPara (a, b)
{
    return (a.key == b.key && a.value == b.value);
}

function findECCEIDV (a, b)
{
    var s = a.split(',');
    return parseInt(s[0], 16) == b[0] && parseInt(s[1], 16) == b[1];
}

function findIDVECIDV (a, b)
{
    var s = b.split('-');
    return a.key == parseInt(s[1]) && a.value == parseInt(s[0]);
}

function findCfgType (a, b)
{
    return parseInt(a, 16) == b;
}

function adjSegByBitmask(strIP, strBitM)
{
    var arrItem = strIP.split(".");
    var finalIP = "";
    var bitmask = parseInt(strBitM);
    var value;

    for (var i = 0; i<arrItem.length; i++, bitmask -= 8) {
        value = parseInt(arrItem[i]);
        if (bitmask >= 8)
            finalIP += arrItem[i];
        else if (bitmask <= 0)
            finalIP += "0";
        else {
            finalIP += (value & ((Math.pow(2, bitmask) - 1) << (8 - bitmask))).toString();
        }
        if (i < arrItem.length - 1)
            finalIP += ".";
    }
    return finalIP;
}

function cids (msk)
{
    var v = msk.split('.');
    var m = 0;

    for (var j = i = 0; i < 4; i++) {
        var u = parseInt(v[i]);
        for (j = 0; j < 8; j++, u >>= 1) {
            if (u & 0x1)
                m++;
        }
    }
    if (m == 0)
        m = '';
    return m;
}

function rcids (msk)
{
    var v = parseInt(msk), u = v;
    var s = '';
    var i = 0, j = 0, w = 1, x = 0;

    for (i = 0, j = 0, w = 128, x = 0; i < v; i++, j++) {
        if (j == 8) {
            j = 0;
            s += '.' + x;
            w = 128;
            x = 0;
        }
        x += w;
        w >>= 1;
    }

    for (; i < 32; i++, j++) {
        if (j == 8) {
            j = 0;
            s += '.' + x;
            x = 0;
        }
    }
    if (j == 8) {
        s += '.' + x;
    }

    return s.substr(1);
}

function sortIPAddrSeg (x, y)
{
    var r = 0, m, n, a, b;

    a = x.split('/');
    b = y.split('/');
    m = a[0].split('.');
    n = b[0].split('.');
    if ((x = parseInt(m[0])) == (y = parseInt(n[0]))) {
        if ((x = parseInt(m[1])) == (y = parseInt(n[1]))) {
            if ((x = parseInt(m[2])) == (y = parseInt(n[2]))) {
                if ((x = parseInt(m[3])) == (y = parseInt(n[3]))) {
                    x = parseInt(a[1]);
                    y = parseInt(b[1]);
                }
            }
        }
    }

    if (x > y)
        r = 1;
    else if (x == y)
        r = 0;
    else
        r = -1;

    return r;
}
