// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

function addSubMenuOfFRUInfo (displayname)
{
    var i, j, k, n, tmpArray = new Array(), tmpArray2 = new Array();

    for (k = j = i = 0; i < parent.once.theFRUInfo.length(); i++) {
        if (k == 0 || (k > 0 && tmpArray[k - 1] != parent.once.theFRUInfo.at(i).key.key)) {
            tmpArray[k++] = parent.once.theFRUInfo.at(i).key.key;
            n = parent.once.theFRUInfo.at(i).extra.key;
            tmpArray2[parent.once.theFRUInfo.at(i).key.key] = (n ? n: parent.I18N['UNKNOWN']);

        }
    }
    var frumenu = parent.once.theTopMenu.idAt('INVENTORY').idAt(parent.asLbID['ASWM_CFGGROUP_FRUINFO']);
    for (i = 0; i < tmpArray.length; i++) {
        if (i == 0) {
            frumenu.addSubMenu(new PopupMenuItem (parent.asLbID['ASWM_CFGGROUP_FRUINFO'], tmpArray2[tmpArray[i]], displayname));
        }
        frumenu.addSubMenu(new PopupMenuItem (parent.asLbID['ASWM_CFGGROUP_FRUINFO'] + ',' + tmpArray[i], tmpArray2[tmpArray[i]], displayname));
    }
}

function addSubMenuOfEventMan (displayname)
{
    var evmenu = parent.once.theTopMenu.idAt('CONFIGURATION').idAt(parent.asLbID['ASWM_CFGGROUP_EVENT']);
    evmenu.addSubMenu(new PopupMenuItem (parent.asLbID['ASWM_CFGGROUP_EVENT'], parent.I18N['EVENT_MANAGER'], displayname));
    evmenu.addSubMenu(new PopupMenuItem (parent.asLbID['ASWM_CFGGROUP_EVENTCONSUMER'], parent.I18N['EVENT_CONSUMER'], displayname));
    evmenu.addSubMenu(new PopupMenuItem (parent.asLbID['ASWM_CFGGROUP_EVENTFILTER'], parent.I18N['EVENT_FILTER'], displayname));
}

function sortFRUInfo (a, b)
{
    var x = a.key.key;
    var y = b.key.key;

    if (x != y) {
        return x - y;
    }

    x = a.key.value;
    y = b.key.value;

    if (x != y) {
        return x - y;
    }

    x = a.key.extra;
    y = b.key.extra;

    if (x != y) {
        return x - y;
    }

    return 0;
}

function findFRUInfo (a, b)
{
    return a.key.key == b.key && a.key.value == b.value && a.key.extra == b.extra;
}

function findFRU (i, j, k)
{
    if (parent.once.theFRUInfo) {
        var a = parent.once.theFRUInfo.atComp(new triple(i, j, k), parent.once.findFRUInfo);
        if (a) {
            return a.value;
        }
    }
    return false;
}

function findDMI (dmistru, i, cc)
{
    if (dmistru) {
        var a = dmistru.tripleExtraAt(i);
        if (a) {
            return a.keyAt(cc);
        }
    }
    return false;
}

function findIPMI (ipmistru, key)
{
    if (ipmistru) {
        var a = ipmistru.quintupleMiscAt(key);
        return a;
    }
    return false;
}

function smbios_dimmsize (b)
{
    var x = b & 0x7f;

    switch (x) {
        case 0x7f:
            return parent.I18N['NOT_INSTALLED'];
        case 0x7e:
            return parent.I18N['DISABLED'];
        case 0x7d:
            return parent.I18N['UNKNOWN_SIZE'];
        default:
            return Math.pow(2, x).toString() + ' MB';
    }
    return '';
}